// Windows-specific token interactivity.
// As well as shield keeping between levels
// and special stages.

local netframework = CV_RegisterVar({ // Compromise with having default special stages.
	name = "TokenCompile",
	defaultvalue = 0,
	flags = CV_NETVAR | CV_SHOWMODIF,
	PossibleValue = {default=0, legacy=1}
})

local function Token2GemSFX()
	S_StartSound(nil, sfx_cgot)
	S_StartSound(nil, sfx_chchng)
end

local function TokenWindowsReward()
	for player in players.iterate
		P_GivePlayerRings(player, 50) // Rings, people, Rings!
		S_StartSound(player.mo, sfx_cdfm67, player)
	end
end

// The old special stages continue Lua.
// Script by SteelT.
local therings = 0

addHook("MapLoad", function(gamemap)
	therings = 0
	if (multiplayer) then return end
	if (maptol & TOL_NIGHTS) then return end
	if (G_IsSpecialStage(gamemap)) then
		for ring in mobjs.iterate() do
			if (ring.type == MT_RING)
				therings = $ + 1
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if (multiplayer) then return end
	if (maptol & TOL_NIGHTS) then return end
	if (G_IsSpecialStage(gamemap)) then
		if (therings > 0 and player.rings >= therings/2) and (not player.gotcontinue) then
			player.gotcontinue = 1
			player.continues = $ + 1
			S_StartSound(nil, sfx_s3kac, player)
		end
	end
end)

// From KeepShield V3 by Zippy_Zolton.
// Be smart with which shield you finish a level with.
// Might help you or end up being useless.
addHook("PlayerThink", function(player)
	if player.mo.skin != "windows" then return
	elseif player.mo.skin == "windows" then
		if not (player and player.mo and player.mo.valid and player.exiting and (gametyperules & GTR_FRIENDLY)) return end
		player.shieldtransfer = player.powers[pw_shield]
	end
end)

addHook("PlayerSpawn", function(player)
	if player.shieldtransfer == nil or not (gametyperules & GTR_FRIENDLY) then return end
	if player.mo.skin != "windows" then return
	elseif player.mo.skin == "windows" then
		player.powers[pw_shield] = player.shieldtransfer
		P_SpawnShieldOrb(player)
		player.shieldtransfer = nil
	end
end)

// Actual token shenanigans.
addHook("TouchSpecial", function(special, grabber)
	if (grabber and grabber.valid) and grabber.skin != "windows" then return
	elseif (grabber and grabber.valid) and grabber.skin == "windows" then
		if netframework.value == 1 then
			if emeralds & EMERALD1 == 0 then
				emeralds = $ | EMERALD1
				Token2GemSFX()
				P_AddPlayerScore(grabber.player, 10000)
			elseif emeralds & EMERALD2 == 0 then
				emeralds = $ | EMERALD2
				Token2GemSFX()
				P_AddPlayerScore(grabber.player, 10000)
			elseif emeralds & EMERALD3 == 0 then
				emeralds = $ | EMERALD3
				Token2GemSFX()
				P_AddPlayerScore(grabber.player, 10000)
			elseif emeralds & EMERALD4 == 0 then
				emeralds = $ | EMERALD4
				Token2GemSFX()
				P_AddPlayerScore(grabber.player, 10000)
			elseif emeralds & EMERALD5 == 0 then
				emeralds = $ | EMERALD5
				Token2GemSFX()
				P_AddPlayerScore(grabber.player, 10000)
			elseif emeralds & EMERALD6 == 0 then
				emeralds = $ | EMERALD6
				Token2GemSFX()
				P_AddPlayerScore(grabber.player, 10000)
			elseif emeralds & EMERALD7 == 0 then
				emeralds = $ | EMERALD7
				Token2GemSFX()
				P_AddPlayerScore(grabber.player, 10000)
			else TokenWindowsReward() end
		else
			if not All7Emeralds(emeralds) then
				token = $ + 1
				S_StartSound(grabber, sfx_zelda)
			else
				TokenWindowsReward()
			end
			P_AddPlayerScore(grabber.player, 10000)
			S_StartSound(grabber, sfx_chchng)
		end
		P_KillMobj(special)
		return true
	end
end, MT_TOKEN)