// HUD stuffing.
local iswindows = false
local fader = 0
local mpeg = 3
local winglow = 0
local tokenpresent = false
local location = 0
local sscheck = 0

addHook("MapLoad", function(gamemap)
	location = mapheaderinfo[gamemap].nextlevel
	if (G_IsSpecialStage(gamemap)) then
		sscheck = true
	else
		sscheck = false
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid and player.mo.skin == "windows" then
		iswindows = true
	else
		iswindows = false
	end
end)

local function WinHUD(v, player)
	if player.mo and player.mo.valid and player.mo.skin == "windows" then
		if player.winpopup != nil and player.xpcooldown != nil then
			local winready = v.cachePatch("WINREADY")
			local winwarn = v.cachePatch("WINWARN")
			local kgrow = v.cachePatch("KGROW")
			local winnotready = v.cachePatch("WINNOT")
			local directx = v.cachePatch("WINDX")
			local directxbw = v.cachePatch("WINDX1")
			local spiking = v.cachePatch("WINBUST")
			local growth = CV_FindVar("kartgrow")
			local directxtoggle = CV_FindVar("DirectX")
			local kflash = leveltime%2
			local fadetime = leveltime%4
			local run = (15*TICRATE - player.winpopup) / TICRATE
			local clocking = (60*TICRATE - player.xpcooldown) / TICRATE
			local growthtimer = (player.powers[pw_sneakers] / TICRATE)
			local levelend = v.cachePatch("BLACKBG")
			if player.powers[pw_super] != 0 then
				if player.xpcooldown != 60*TICRATE then
					v.draw(17, 141, winnotready, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
					v.drawString(37, 145, (clocking), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS|V_GRAYMAP, "thin")
				elseif player.xpcooldown == 60*TICRATE then
					if player.hyper == nil or player.hyper.capable == false then
						v.draw(17, 141, winready, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
						v.drawString(37, 145, ("Ready"), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS|V_GREENMAP, "thin")
					elseif player.hyper and player.hyper.capable == true
						v.draw(17, 141, winwarn, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
						v.drawString(37, 145, ("Ready"), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS|V_YELLOWMAP, "thin")
					end
				end
			end
			if growth.value == 1 and player.powers[pw_sneakers] != 0 then
				if kflash == 1 then
					v.draw(292, 10, kgrow, V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
				end
				if player.powers[pw_sneakers] >= 3*TICRATE then
					v.drawString(300, 16, growthtimer, V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANSDOUBLE|V_BLUEMAP, "center")
				elseif player.powers[pw_sneakers] < 3*TICRATE then
					if kflash == 1 then v.drawString(300, 16, growthtimer, V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANSDOUBLE|V_REDMAP, "center") end
				end
			end
			if directxtoggle.value == 1 then
				if player.winpopup == 15*TICRATE then
					v.draw(16, 158, directx, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
					v.drawString(37, 162, ("Ready"), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS|V_YELLOWMAP, "thin")
				elseif player.winpopup < 15*TICRATE then
					v.draw(16, 158, directxbw, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
					v.drawString(37, 162, run, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS|V_GRAYMAP, "thin")
				end
			end
			if player.exiting == 0 then
				if (player.powers[pw_super] != 0 or player.powers[pw_invulnerability] != 0) then
					v.draw(16, 125, spiking, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
				elseif player.cpanel > 0 then
					v.draw(16, 125, spiking, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
				elseif player.speed > 35*FRACUNIT then
					v.draw(16, 125, spiking, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
				end
				fader = 0
			elseif player.exiting >= 1 then
				if not (sscheck) then
					if (fadetime == 1 and fader < 31) then fader = $ + 1 end
					v.fadeScreen(65280, fader)
					if fader == 31 then v.drawFill() end
				end
				if token > 0 then tokenpresent = true 
				else tokenpresent = false end
			end
		end
	end
end

local function WinInter(v)
	if not iswindows then return end
	local bar = v.cachePatch("WINBAR")
	local flash1 = v.cachePatch("WINBAR1")
	local flash2 = v.cachePatch("WINBAR2")
	local flash3 = v.cachePatch("WINBAR3")
	local flash4 = v.cachePatch("WINBAR4")
	local flash5 = v.cachePatch("WINBAR5")
	local flash6 = v.cachePatch("WINBAR6")
	local flash7 = v.cachePatch("WINBAR7")
	local winbg = v.cachePatch("WINCLRBG")
	v.drawFill()
	v.draw(0, 0, winbg, V_SNAPTOTOP|V_SNAPTOLEFT)
	v.draw(0, 177, bar, V_SNAPTOBOTTOM|V_SNAPTOLEFT)
	if mpeg > 0 then mpeg = $ - 1
	else
		mpeg = 3
		if winglow < 14 then
			winglow = $ + 1
		end
	end
	if winglow > 0 and winglow < 14 then
		if winglow == 1 then v.draw(0, 177, flash1, V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		elseif winglow == 2 then v.draw(0, 177, flash2, V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		elseif winglow == 3 then v.draw(0, 177, flash3, V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		elseif winglow == 4 then v.draw(0, 177, flash4, V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		elseif winglow == 5 then v.draw(0, 177, flash5, V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		elseif winglow == 6 then v.draw(0, 177, flash6, V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		elseif winglow == 7 then v.draw(0, 177, flash7, V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		elseif winglow == 8 then v.draw(0, 177, flash6, V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		elseif winglow == 9 then v.draw(0, 177, flash5, V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		elseif winglow == 10 then v.draw(0, 177, flash4, V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		elseif winglow == 11 then v.draw(0, 177, flash3, V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		elseif winglow == 12 then v.draw(0, 177, flash2, V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		elseif winglow == 13 then v.draw(0, 177, flash1, V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		end
	else
		winglow = 0
	end
	if tokenpresent then
		v.drawString(38, 185, ("Getting ready for a special stage..."), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_REDMAP, "thin")
	elseif location == 1100 or location == 1101 or location == 1102 or location == 1103 then
		v.drawString(38, 185, ("Removing used temporary files..."), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_REDMAP, "thin")
	else
		v.drawString(38, 185, ("Getting ready for the next act..."), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_REDMAP, "thin")
	end
end
hud.add(WinHUD, "game")
hud.add(WinInter, "intermission")