// Custom Lua for File Toss.
// Hello, Mario.

// Faster file access... without TRIM.
// Enable at your own risk!

local intenserecycle = CV_RegisterVar({ 
	name = "ssd",
	defaultvalue = 0,
	flags = CV_NETVAR | CV_SHOWMODIF,
	PossibleValue = CV_YesNo
})

freeslot("SFX_FILETH")

sfxinfo[sfx_fileth] = {
        singular = false,
        priority = 42,
        flags = SF_X2AWAYSOUND,
		caption = "Recycle Bin"
}

addHook("PlayerThink", function(player)
	if (player.mo and player.mo.valid) and player.mo.skin == "windows" then
		if player.baudrate == nil then player.baudrate = 0 end
			if player.baudrate < 19 and gamestate != 4 then
				player.baudrate = $ + 1
			end
			if player.mo.state != S_PLAY_FIRE and player.mo.state != S_PLAY_FIRE_FINISH
				player.targetfile = P_LookForEnemies(player, false, true)
			end
			if (player.targetfile and player.targetfile.valid and player.targetfile.health) then
				if player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_RUN or (player.pflags & PF_JUMPED) or player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WAIT then
					P_SpawnLockOn(player, player.targetfile, S_LOCKON1)
				end
				if player.cmd.buttons & BT_SPIN or player.cmd.buttons & BT_ATTACK then
					if player.baudrate >= 19 and P_PlayerInPain(player) == false and player.playerstate != PST_DEAD and player.exiting == 0 then
						if player.targetfile and player.targetfile.valid then
							if player.powers[pw_super] != 0 then
								if intenserecycle.value == 1 then player.baudrate = 18
								else player.baudrate = 14 end
							else
								if intenserecycle.value == 1 then player.baudrate = 10
								else player.baudrate = 0 end
							end
							P_SpawnMissile(player.mo, player.targetfile, MT_WINFILE)
						else
							if player.powers[pw_super] != 0 then
								if intenserecycle.value == 1 then player.baudrate = 18
								else player.baudrate = 14 end
							else
								if intenserecycle.value == 1 then player.baudrate = 10
								else player.baudrate = 0 end
							end
							P_SpawnPlayerMissile(player.mo, MT_WINFILE, (MF2_EXPLOSION | MF2_SUPERFIRE))
						end
					end
				end
			else
				// No shooting willy nilly if you already are using Rings as ammo.
				// You'd have to have someone between you and the monitor to hit them
				// with a file instead. Not likely, but it might happen anyway.
				if G_RingSlingerGametype() == true then return end
				if player.baudrate >= 19 and P_PlayerInPain(player) == false and player.playerstate != PST_DEAD and player.exiting == 0 then
					if player.cmd.buttons & BT_SPIN or player.cmd.buttons & BT_ATTACK then
						if player.powers[pw_super] != 0 then
							if intenserecycle.value == 1 then player.baudrate = 18
							else player.baudrate = 14 end
						else
							if intenserecycle.value == 1 then player.baudrate = 10
							else player.baudrate = 0 end
						end
					P_SpawnPlayerMissile(player.mo, MT_WINFILE, (MF2_EXPLOSION | MF2_SUPERFIRE))
				end
			end
		end
	end
end)